<?php

namespace ACL\Controllers;

use ACL\Traits\TResponse;
use Exception;
use Zeedhi\Framework\DTO\Request;
use ACL\Services\OperadorLabelVersao as OperadorLabelVersaoService;

class OperadorLabelVersao {

    use TResponse;

    /**
     * @var OperadorLabelVersaoService
     */
    private $operadorLabelVersaoService;

    /**
     * OperadorLabelVersaoService constructor.
     * @param OperadorLabelVersaoService $operadorLabelVersaoService
     */
    public function __construct(OperadorLabelVersaoService $operadorLabelVersaoService)
    {
        $this->operadorLabelVersaoService = $operadorLabelVersaoService;
    }

    /**
     * @param Request $request
     * @return void
     * @throws Exception
     */
    public function findByOperadorAndProject(Request $request)
    {
        try {
            $data = $this->operadorLabelVersaoService->findByOperadorAndProject();
            $this->sendResponse($this->createResponse($data), 200);
        } catch (Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
