<?php

namespace ACL\Controllers;

use ACL\Traits\TResponse;
use Exception;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use ACL\Helpers\Instances\InstanceProvider;
use ACL\Util\AclUtilities;
use ACL\Services\Pais as PaisService;

class Pais {

    use TResponse;

    /**
     * @var PaisService
     */
    private $paisService;

    public function __construct(PaisService $paisService)
    {
        $this->paisService = $paisService;
    }

    public function findAllPais(Request $request, Response $response)
    {
        try {
            $data = $this->paisService->findAllPais();
            $this->sendResponse($data, 200);
        } catch (Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
